module quicksort_hkli;
{}
(******************************************************************************)
(*                                                                            *)
(*             Author : J.Jansen             Date : 23 November 1988          *)
(*                                                                            *)
(*----------------------------------------------------------------------------*)
(*                                                                            *)
(* Quick sort procedure on 2-theta in the common block geind                  *)
(*                                                                            *)
(*----------------------------------------------------------------------------*)
(*                                                                            *)
(*     Variable          Type                 Purpose                         *)
(*     start            integer*2      Start of sorting                       *)
(*     finish           integer*2      End of sorting                         *)
(*     middle_low       integer*2      Lower partition boundary               *)
(*     middle_up        integer*2      Upper partition boundary               *)
(*                                                                            *)
(*----------------------------------------------------------------------------*)
(*                                                                            *)
(*    Calls procedure : partition_hkli                                        *)
(*                                                                            *)
(******************************************************************************)
{}
  type word = [word]-32768..32767;
{}
  [global]procedure quicksort_hkli( start , finish : word );
{}
    procedure partition_hkli( start , finish : word; var middle_up , middle_low
         : word ); extern;
{}
    var
      middle_up,
      middle_low : word;
{}
    begin
      if start < finish then
        begin
          partition_hkli( start , finish , middle_up , middle_low );
          quicksort_hkli( start , middle_low );
          quicksort_hkli( middle_up , finish );
        end;
    end;
end.
