      subroutine read_hklif( lun )
c
******************************************************************************
*                                                                            *
*             Author : J.Jansen                  Date : 8 September 1987     *
*                                                                            *
*----------------------------------------------------------------------------*
*                                                                            *
* Routine to read data from a Philips-powder-diffraction file of the ii- or  *
*  the if-type                                                               *
*                                                                            *
*----------------------------------------------------------------------------*
*                                                                            *
*     Variable        Type                  Purpose                          *
*     lun           integer        Logical unit number datafile              *
*     dummy         integer*2(256) Contents of the current record            *
*     numrec        integer        Number of records to read completely      *
*     numrest       integer        Number o peaks to get from the last       *
*                                   record                                   *
*     ncount        integer        Counter                                   *
*     i             integer        Do-loop parameter                         *
*     j             integer        Do-loop parameter                         *
*     ihelp         integer        Help parameter                            *
*     jhelp         integer*2(2)   Help parameter                            *
*                                                                            *
*----------------------------------------------------------------------------*
*                                                                            *
*     Calls subroutine : unpack_hkl                                          *
*     Calls functions :  unpack_ang                                          *
*                        unpack_counts                                       *
*                                                                            *
******************************************************************************
c
      include '$disk2:[joukj.powder.source]common_uhdi.inc/list'
c
      include '$disk2:[joukj.powder.source]common_geind.inc/list'
c
      integer*2 dummy(256) , jhelp( 2 )
c
      equivalence ( ihelp , jhelp( 1 ) )
c
c Determin the number of records of 51 peaks has to be read and read these
      numrec = npk / 51
      ncount = 0
      do i = 1 , numrec
        read( lun , rec=i+1) dummy
        do j = 1 , 51
          ncount = ncount + 1
          jhelp( 1 ) = dummy(5*(j-1)+2)
          jhelp( 2 ) = dummy(5*(j-1)+3)
          call unpack_hkl( ih( ncount ) , ik( ncount ) , il( ncount ) ,
     >             ihelp )
          theta2( ncount ) = unpack_ang( dummy(5*(j-1)+4) )
          count( ncount ) = unpack_counts ( dummy(5*(j-1)+5) )
          ercount( ncount ) = unpack_counts( dummy(5*(j-1)+6) )
         end do
      end do
c
c Determin the number of peaks in the last record and read these
      numrest = npk - numrec * 51
      if ( numrest .ne. 0) then
        read (lun , rec=numrec+2) dummy
        do i = 1,numrest
          ncount = ncount + 1
          jhelp( 1 ) = dummy(5*(i-1)+2)
          jhelp( 2 ) = dummy(5*(i-1)+3)
          call unpack_hkl( ih( ncount ) , ik( ncount ) , il( ncount ) ,
     >             ihelp )
          theta2( ncount ) = unpack_ang( dummy(5*(i-1)+4) )
          count( ncount ) = unpack_counts ( dummy(5*(i-1)+5) )
          ercount( ncount ) = unpack_counts( dummy(5*(i-1)+6) )
        end do
      end if
c
      return
      end
