      subroutine write_hklif( lun )
c
******************************************************************************
*                                                                            *
*             Author : J.Jansen                  Date : 7 September 1987     *
*                                                                            *
*----------------------------------------------------------------------------*
*                                                                            *
* Routine to put the indices angle positions and the intensities of the      *
*  peaks into a Philips-powder-diffraction file of the ii-type               *
*                                                                            *
*----------------------------------------------------------------------------*
*                                                                            *
*     Variable        Type                  Purpose                          *
*     lun           integer        Logical unit number datafile              *
*     dummy         integer*2(256) Contents of the current record            *
*     numrec        integer        Number of records to write completely     *
*     numrest       integer        Number o peaks to put into the last       *
*                                   record                                   *
*     i             integer        Do-loop parameter                         *
*     j             integer        Do-loop parameter                         *
*     ihelp         integer        Help parameter                            *
*     jhelp         integer*2(2)   Help parameter                            *
*                                                                            *
*----------------------------------------------------------------------------*
*                                                                            *
*         Calls functions : pack_ang                                         *
*                           pack_counts                                      *
*                           pack_hkl
*                                                                            *
******************************************************************************
c
      include '$disk2:[joukj.powder.source]common_uhdi.inc/list'
c
      include '$disk2:[joukj.powder.source]common_geind.inc/list'
c
      integer*2 dummy(256) , pack_ang , pack_counts , jhelp( 2 )
      integer pack_hkl
c
      equivalence ( ihelp , jhelp( 1 ) )
c
c Determin the number of records of 51 peaks has to be write and write these
      numrec = npk / 51
      ncount = 0
      dummy(1) = 51
      do i = 1 , numrec
        do j = 1 , 51
          ncount = ncount + 1
          ihelp = pack_hkl( ih( ncount ) , ik( ncount ) , il( ncount ) )
          dummy(5*(j-1)+2) = jhelp( 1 )
          dummy(5*(j-1)+3) = jhelp( 2 )
          dummy(5*(j-1)+4) = pack_ang( theta2( ncount ) )
          dummy(5*(j-1)+5) = pack_counts( count( ncount ) )
          dummy(5*(j-1)+6) = pack_counts( ercount( ncount ) )
        end do
        write( lun , rec=i+1) dummy
      end do
c
c Determin the number of peaks in the last record and write these
      numrest = npk - numrec * 51
      if ( numrest .ne. 0) then
        dummy(1) = numrest
        do i = 1,numrest
          ncount = ncount + 1
          ihelp = pack_hkl( ih( ncount ) , ik( ncount ) , il( ncount ) )
          dummy(5*(i-1)+2) = jhelp( 1 )
          dummy(5*(i-1)+3) = jhelp( 2 )
          dummy(5*(i-1)+4) = pack_ang( theta2( ncount ) )
          dummy(5*(i-1)+5) = pack_counts( count( ncount ) )
          dummy(5*(i-1)+6) = pack_counts( ercount( ncount ) )
        end do
        write (lun , rec=numrec+2) dummy
      end if
c
      return
      end
